//
//  ViewController.m
//  ex_faceUpDown-fadeInOut
//
//  Created by yoshiyuki oshige on 2013/05/28.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
- (void)changedDeviceOrientation:(id)sender;
- (void) fadeInOut:(UIImageView *)imageView alpha:(float)alphaV;
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    //トンボを消しておく
    _tombo.alpha = 0;
	//通知センターにデバイス回転のオブザーバとして登録する
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(changedDeviceOrientation:)
                                                 name:UIDeviceOrientationDidChangeNotification
                                               object:nil];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//デバイスの向きが変わったら通知される
- (void)changedDeviceOrientation:(id)sender {
    switch ([[UIDevice currentDevice] orientation]) {
        case UIDeviceOrientationFaceUp://表向き
            //トンボが消える
            [self fadeInOut:_tombo alpha:0];
            [self fadeInOut:_photo alpha:1.0];
            break;
        case UIDeviceOrientationFaceDown://裏向き
            //トンボが現れ、写真は薄くなる
            [self fadeInOut:_tombo alpha:1.0];
            [self fadeInOut:_photo alpha:0.2];
            break;
        default:
            break;
    }
}

//フェードイン／フェードアウト
- (void) fadeInOut:(UIImageView *)imageView alpha:(float)alphaV
{
    //アニメーションのオプション
    UIViewAnimationOptions options = UIViewAnimationOptionBeginFromCurrentState
        | UIViewAnimationOptionAllowUserInteraction
        | UIViewAnimationOptionCurveEaseInOut;
    
    //アニメーションの実行
    [UIView animateWithDuration:0.5
                          delay:0.0
                        options:options
                     animations:^{
                         imageView.alpha = alphaV;
                     }
                     completion:nil];
}

@end
