//
//  ViewController.m
//  ex_CMMotionManager_accelerometer-pull
//
//  Created by yoshiyuki oshige on 2013/05/29.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//


#import "ViewController.h"

@interface ViewController ()
{
    CMMotionManager *motionManager;
     NSTimer *timerObj;
}
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//加速度センサーの利用開始と終了
- (IBAction)startStop:(UISwitch *)sender {
    if(sender.on){
        if(! motionManager){
            //モーションマネージャを作る
            motionManager = [[CMMotionManager alloc] init];
            motionManager.accelerometerUpdateInterval = 0.002;
        }
        //センサーの利用を開始する
        [motionManager startAccelerometerUpdates];
        //タイマーを作って動かす
        timerObj = [NSTimer scheduledTimerWithTimeInterval:0.5 //0.5秒間隔で更新
                                                    target:self
                                                  selector:@selector(stepAnimation:)
                                                  userInfo:nil
                                                   repeats:YES];
    } else {
        //センサーの利用を終了する
        [motionManager stopAccelerometerUpdates];
        //タイマーを終了する
        [timerObj invalidate];
    }
}

//アニメーションの内容
- (void)stepAnimation:(NSTimer *)timer
{
    //加速度センサーのデータを取り出す
    CMAccelerometerData *data = motionManager.accelerometerData;
    double time = data.timestamp;//経過時間
    double accx = data.acceleration.x;// X軸: 加速度G
    double accy = data.acceleration.y;// Y軸: 加速度G
    double accz = data.acceleration.z;// Z軸: 加速度G
    _labelTime.text = [NSString stringWithFormat:@"%.2f", time];
    _labelX.text = [NSString stringWithFormat:@"x= %.4f", accx];
    _labelY.text = [NSString stringWithFormat:@"y= %.4f", accy];
    _labelZ.text = [NSString stringWithFormat:@"z= %.4f", accz];
}

@end