//
//  ViewController.m
//  ex_CMMotionManager_accelerometer
//
//  Created by yoshiyuki oshige on 2013/05/29.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
{
    CMMotionManager *motionManager;
    double speedx;
    double speedy;
}
- (void)startAnimation;
- (void)animation:(CMAccelerometerData *)data;
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//ビューが表示されたらアニメーションをスタートする
- (void)viewDidAppear:(BOOL)animated
{
    [self startAnimation];
}

//アニメーションのスタート
- (void)startAnimation {
    //モーションマネージャを作る
    motionManager = [[CMMotionManager alloc] init];
    //加速センサーの計測インターバルの設定
    motionManager.accelerometerUpdateInterval = 0.006;// 60Hz
    speedx = 0;
    speedy = 0;
    //定期的に実行するハンドラを設定
    CMAccelerometerHandler handler = ^(CMAccelerometerData *data, NSError *error){
        [self animation:data];
    };
    //加速センサーの利用を開始
    [motionManager startAccelerometerUpdatesToQueue:[NSOperationQueue currentQueue] withHandler:handler];
}

//アニメーションの内容
- (void)animation:(CMAccelerometerData *)data
{
    double time = data.timestamp;//経過時間
    double accx = data.acceleration.x;// X軸: 加速度G
    double accy = data.acceleration.y;// Y軸: 加速度G
   // double accz = data.acceleration.z;// Z軸: 加速度G
    
    //傾いた方へ落下する
    speedx += accx;
    speedy += accy;
    double cx = _ball.center.x + speedx;
    double cy = _ball.center.y - speedy;

    //画面の縦横サイズ
    double width = self.view.bounds.size.width;
    double height = self.view.bounds.size.height;
    
    //壁で跳ね返る
    if((cx<0)&&(speedx<0)){
        speedx = -1*speedx/2;
    }else if((cx>width)&&(speedx>0)){
        speedx = -1*speedx/2;
    }
    if((cy<0)&&(speedy>0)){
        speedy = -1*speedy/2;
    }else if((cy>height)&&(speedy<0)){
        speedy = -1*speedy/2;
    }
    
    //ボールを動かす
    _ball.center = CGPointMake(cx, cy);
    //経過時間
    _myLabel.text = [NSString stringWithFormat:@"%.2f", time];
}

@end
