//
//  ViewController.m
//  ex_CMMotionManager_deviceMotion
//
//  Created by yoshiyuki oshige on 2013/06/01.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
{
    CMMotionManager *motionManager;
}
- (void)startAnimation;
- (void)animation:(CMDeviceMotion *)motion;
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//ビューが表示されたらアニメーションをスタートする
- (void)viewDidAppear:(BOOL)animated
{
    [self startAnimation];
}

//アニメーションのスタート
- (void)startAnimation {
    //モーションマネージャを作る
    motionManager = [[CMMotionManager alloc] init];
    if(! motionManager.deviceMotionAvailable){
        return;
    }
    motionManager.deviceMotionUpdateInterval = 0.006;// 60Hz
    // ハンドラを指定
    CMDeviceMotionHandler handler = ^(CMDeviceMotion *motion, NSError *error){
        [self animation:motion];
    };
    //デバイスモーションの利用を開始する
    [motionManager startDeviceMotionUpdatesToQueue:[NSOperationQueue currentQueue] withHandler:handler];
}

//アニメーションの内容
- (void)animation:(CMDeviceMotion *)motion
{
    double time = motion.timestamp;//経過時間
    double roll = motion.attitude.roll;// Y軸回りの回転角度（ラジアン）
    double pitch = motion.attitude.pitch;// X軸回りの回転角度（ラジアン）
    double yaw = motion.attitude.yaw;// Z軸回りの回転角度（ラジアン）
    
    //デバイスの画面サイズを1として中央が基準になるように動かす
    double width = self.view.bounds.size.width;
    double height = self.view.bounds.size.height;
    double cx = width * roll/M_PI;
    double cy = height * pitch/M_PI;
    
    /* ufoを動かす */
    //回転トランスフォーム
    CGAffineTransform tf1 = CGAffineTransformMakeRotation(yaw);
    //移動トランスフォーム
    CGAffineTransform tf2 = CGAffineTransformMakeTranslation(cx, cy);
    //トランスフォームの合成：
    _ufo.transform = CGAffineTransformConcat(tf1, tf2);
    
    //経過時間
    _myLabel.text = [NSString stringWithFormat:@"%.2f", time];
}

@end