//
//  ViewController.m
//  ex_MapKit
//
//  Created by yoshiyuki oshige on 2013/06/02.
//  Copyright (c) 2013年 yoshiyuki. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    //デリゲートに設定する
    _myMapView.delegate = self;
    //マップタイプを選ぶ
    _myMapView.mapType = MKMapTypeStandard;
    //地図に現在地を表示する
    _myMapView.showsUserLocation = YES;
    //Floowボタンをダークグレイにする
    [_barButton_follow setTintColor:[UIColor darkGrayColor]];
    _label_trackingMode.text = @"None";
}

//Followボタンがタップされた
- (IBAction)changeTrackingMode:(UIBarButtonItem *)sender {
    switch (_myMapView.userTrackingMode) {
        case MKUserTrackingModeNone://Non>Follow
            //追従モードを開始し、ボタンを赤色にする
            [_myMapView setUserTrackingMode:MKUserTrackingModeFollow animated:YES];
            [_barButton_follow setTintColor:[UIColor redColor]];
            _label_trackingMode.text = @"Follow";
            break;
        case MKUserTrackingModeFollow://Follow>Heading
            //ヘディングを開始し、ボタンをマゼンタ色にする
            [_myMapView setUserTrackingMode:MKUserTrackingModeFollowWithHeading animated:YES];
            [_barButton_follow setTintColor:[UIColor magentaColor]];
            _label_trackingMode.text = @"Heading";
            break;
        case MKUserTrackingModeFollowWithHeading://Heading>None
            //標準モードに戻し、ボタンをダークグレイにする
            [_myMapView setUserTrackingMode:MKUserTrackingModeNone animated:YES];
            [_barButton_follow setTintColor:[UIColor darkGrayColor]];
            _label_trackingMode.text = @"None";
            break;
        default:
            break;
    }
}

//Go to Spotボタンがタップされた
- (IBAction)gotoSpot:(UIBarButtonItem *)sender {
    CLLocationDegrees latitude = 35.305267;//緯度
    CLLocationDegrees longitude = 139.482358;//経度
    //緯度、経度から表示位置を求める
    CLLocationCoordinate2D center = CLLocationCoordinate2DMake(latitude, longitude);
    //表示領域（中央、縦メートル、横メートル）
    MKCoordinateRegion theSpot =  MKCoordinateRegionMakeWithDistance(center,1000,1000);
    //指定の位置を表示する
    [_myMapView setRegion:theSpot animated:YES];
}


//ユーザートラッキングモードが解除された
- (void)mapView:(MKMapView *)mapView didChangeUserTrackingMode:(MKUserTrackingMode)mode animated:(BOOL)animated
{
    //Followボタンをダークグレイにする
    [_barButton_follow setTintColor:[UIColor darkGrayColor]];
    _label_trackingMode.text = @"None";
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
@end

